| eRPC Generator (erpcgen) Rev. 1.8.1 NXP Semiconductors

- Main Page
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Protected Attributes | List of all members
erpcgen::EnumType Class Reference

Enumerate data type. More...

`#include <EnumType.h>`

Inheritance diagram for erpcgen::EnumType:

## Public Types
typedef std::vector< EnumMember * > | member_vector_t
Public Types inherited from erpcgen::DataType
enum | _data_type { kAliasType, kArrayType, kBuiltinType, kEnumType, kFunctionType, kListType, kStructType, kUnionType, kVoidType }
| Supported data types.
Public Types inherited from erpcgen::Symbol
enum | symbol_type_t { kConstSymbol, kEnumMemberSymbol, kFunctionSymbol, kInterfaceSymbol, kProgramSymbol, kStructMemberSymbol, kTypenameSymbol, kUnionCaseMemberSymbol, kAliasTypeSymbol, kArrayTypeSymbol, kBuiltinTypeSymbol, kEnumTypeSymbol, kFunctionTypeSymbol, kListTypeSymbol, kStructTypeSymbol, kUnionTypeSymbol }
| Supported symbol types.

## Public Member Functions
| EnumType (const Token &tok)
| Constructor. More...
| EnumType ()
| Constructor. More...
void | addMember (EnumMember *newMember)
| This function will add enum member to the enum. More...
member_vector_t & | getMembers ()
| This function returns vector of enum members. More...
EnumMember * | getMember (std::string name)
| This function returns enum member based on given name. More...
virtual bool | isEnum () const
| This function return "true" value for identify enum type. More...
uint32_t | getNextValue ()
| This function returns the next value to use for an enum member. More...
void | setCurrentValue (uint32_t value)
| This function set current value. More...
virtual std::string | getDescription () const
| This function returns description about the enum. More...
Public Member Functions inherited from erpcgen::DataType
| DataType (_data_type dataType)
| Constructor. More...
| DataType (const std::string &name, _data_type dataType)
| Constructor. More...
| DataType (const std::string &name, _data_type dataType, symbol_type_t symbolType)
| Constructor. More...
| DataType (const Token &tok, _data_type dataType, symbol_type_t symbolType)
| Constructor. More...
_data_type | getDataType () const
| This function returns data type. More...
DataType * | getTrueDataType ()
| This function returns pointer to true data type instead of alias. More...
DataType * | getTrueContainerDataType ()
| This function returns pointer to true data type (enum, builtin, structs) except lists and arrays. More...
virtual bool | isAlias () const
| This function return "false" value as default for identify alias type. More...
virtual bool | isArray () const
| This function return "false" value as default for identify array type. More...
virtual bool | isBinary () const
| This function return "false" value as default for identify binary type. More...
virtual bool | isBool () const
| This function return "false" value as default for identify bool type. More...
virtual bool | isBuiltin () const
| This function return "false" value as default for identify builtin type. More...
virtual bool | isFunction () const
| This function return "false" value as default for identify function type. More...
virtual bool | isList () const
| This function return "false" value as default for identify list type. More...
virtual bool | isScalar () const
| This function return "false" value as default for identify scalar builtin type. More...
virtual bool | isString () const
| This function return "false" value as default for identify string type. More...
virtual bool | isUString () const
| This function return "false" value as default for identify ustring type. More...
virtual bool | isStruct () const
| This function return "false" value as default for identify struct type. More...
virtual bool | isUnion () const
| This function return "false" value as default for identify union type. More...
virtual bool | isVoid () const
| This function return "false" value as default for identify void type. More...
Public Member Functions inherited from erpcgen::Symbol
| Symbol (symbol_type_t symType)
| Constructor. More...
| Symbol (symbol_type_t symType, const std::string &name)
| Constructor. More...
| Symbol (symbol_type_t symType, const Token &tok)
| Constructor. More...
virtual | ~Symbol ()
| Destructor.
symbol_type_t | getSymbolType () const
| This function returns symbol type. More...
const std::string & | getName () const
| This function returns symbol name. More...
void | setName (const std::string &newName)
| This function set symbol name. More...
token_loc_t & | getLocation ()
| This function returns location for symbol. More...
void | setLocation (const token_loc_t &loc)
| This function set location for symbol. More...
int | getFirstLine () const
| This function return first line from location of symbol. More...
int | getLastLine () const
| This function return last line from location of symbol. More...
void | addAnnotation (const Annotation &a)
| This function add annotation to vector of symbol annotations. More...
std::string | printAnnotations ()
| This function returns description about annotation. More...
Annotation * | findAnnotation (std::string name, Annotation::program_lang_t lang)
| Find annotation in the annotation list. More...
std::vector< Annotation * > | getAnnotations (std::string name, Annotation::program_lang_t lang)
| Find annotations matching name in the annotation list. More...
const std::vector< Annotation > & | getAnnotations () const
| Return all Symbol annotations. More...
Value * | getAnnValue (const std::string annName, Annotation::program_lang_t lang)
| This function search and returns Value object for given annotation name. More...
std::string | getAnnStringValue (const std::string annName, Annotation::program_lang_t lang)
| This function search and returns string for given annotation name. More...
std::string | getMlComment ()
| This function returns multiline comment for this symbol declared in IDL file. More...
void | setMlComment (std::string comment)
| This function set multiline comment for this symbol declared in IDL file. More...
std::string | getIlComment ()
| This function returns inline comment for this symbol declared in IDL file. More...
void | setIlComment (std::string comment)
| This function set inline comment for this symbol declared in IDL file. More...

## Protected Attributes
member_vector_t | m_members
uint32_t | m_currentValue
Protected Attributes inherited from erpcgen::DataType
_data_type | m_dataType
Protected Attributes inherited from erpcgen::Symbol
symbol_type_t | m_symbolType
std::string | m_name
token_loc_t | m_location
std::vector< Annotation > | m_annotations
std::string | m_mlComment
std::string | m_ilComment

## Detailed Description

Enumerate data type.

## Member Typedef Documentation

typedef std::vector<EnumMember *> erpcgen::EnumType::member_vector_t

Contains list of enum members

## Constructor & Destructor Documentation

erpcgen::EnumType::EnumType | ( | const Token & | tok | ) |
| inline

Constructor.

This function set token to given token.

Parameters

  [in] | tok | Given token.

erpcgen::EnumType::EnumType | ( |  | ) |
| inline

Constructor.

This function set DataType with default name.

## Member Function Documentation

void EnumType::addMember | ( | EnumMember * | newMember | ) |

This function will add enum member to the enum.

The function will add enum member given by pointer newMember to the enum members vector m_members.

Parameters

  [in] | newMember | Enum member pointer, which is added to enum members vector.

string EnumType::getDescription | ( |  | ) | const
| virtual

This function returns description about the enum.

Returns
  String description about enum.

See also
  std::string AliasType::getDescription() const
  std::string EnumMember::getDescription() const
  std::string StructMember::getDescription() const
  std::string StructType::getDescription() const
  std::string VoidType::getDescription() const
  std::string ArrayType::getDescription() const
  std::string ListType::getDescription() const
  std::string UnionType::getDescription() const

Reimplemented from erpcgen::Symbol.

EnumMember * EnumType::getMember | ( | std::string | name | ) |

This function returns enum member based on given name.

Returns
  Enum member.

member_vector_t& erpcgen::EnumType::getMembers | ( |  | ) |
| inline

This function returns vector of enum members.

Returns
  Enum members vector.

uint32_t erpcgen::EnumType::getNextValue | ( |  | ) |
| inline

This function returns the next value to use for an enum member.

Return values

  uint32_t | next value for enum

virtual bool erpcgen::EnumType::isEnum | ( |  | ) | const
| inline virtual

This function return "true" value for identify enum type.

Return values

  true | Always return true.

Reimplemented from erpcgen::DataType.

void erpcgen::EnumType::setCurrentValue | ( | uint32_t | value | ) |
| inline

This function set current value.

Parameters

  [in] | value | Current value.

## Member Data Documentation

uint32_t erpcgen::EnumType::m_currentValue
| protected

Value for enum member.

member_vector_t erpcgen::EnumType::m_members
| protected

Vector of enum members.

The documentation for this class was generated from the following files:

- EnumType.h
- Type.cpp